﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupo.Rotations
{
    public class GladiatorPaladin : KupoRoutine
    {
        public override int PullRange
        {
            get { return 5; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[] { ClassJobType.Gladiator, ClassJobType.Paladin, }; }
        }

        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        protected override Composite CreatePull()
        {
            return new PrioritySelector(
                r => Actionmanager.InSpellInRangeLOS("Fast Blade", Core.Target),
                new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                Cast("Fast Blade", r => (r as SpellRangeCheck?) == SpellRangeCheck.Success || (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInFront)
            );


        }

        protected override Composite CreateCombat()
        {
            return new PrioritySelector(

                Cast("Riot Blade", r => Actionmanager.LastSpell.Name == "Savage Blade"),//Check for mana level at higher level when theother combo action is avail
                Cast("Savage Blade", r => Actionmanager.LastSpell.Name == "Fast Blade"),
                Cast("Fast Blade", r => true)// r => Actionmanager.LastSpellId == 0 || Actionmanager.LastSpell.Name == "Full Thrust" )


                );
        }
    }
}
