﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupo.Rotations
{
    public class LancerDragoon : KupoRoutine
    {
        public override int PullRange
        {
            get { return 5; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[]{ClassJobType.Dragoon, ClassJobType.Lancer, };}
        }

        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }


        protected override Composite CreateCombatBuffs()
        {
            return new PrioritySelector(

                Apply("Invigorate",r=> Core.Player.CurrentTPPercent <= 40,r=>Core.Player)
);
        }

        protected override Composite CreatePull()
        {
            return new PrioritySelector(
                r => Actionmanager.InSpellInRangeLOS("True Thrust", Core.Target),
                new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                Cast("True Thrust", r => (r as SpellRangeCheck?) == SpellRangeCheck.Success || (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInFront)
            );


        }

        protected override Composite CreateCombat()
        {
            return new PrioritySelector(
                Cast("Heavy Thrust", r => Core.Player.CurrentTarget.IsFlanking && !Core.Player.HasAura("Heavy Thrust")),


                Apply("Phlebotomize", r => Actionmanager.LastSpell.Name != "Impulse Drive"),
                Apply("Chaos Thrust", r => Actionmanager.LastSpell.Name == "Disembowel"),
                Apply("Disembowel", r => Actionmanager.LastSpell.Name == "Impulse Drive"),
                Cast("Impulse Drive", r => Core.Player.CurrentTarget.IsBehind && !Core.Player.CurrentTarget.HasAura("Disembowel") && Actionmanager.HasSpell("Disembowel")),


                Cast("Full Thrust", r => Actionmanager.LastSpell.Name == "Vorpal Thrust"),
                Cast("Vorpal Thrust", r => Actionmanager.LastSpell.Name == "True Thrust"),
                Cast("True Thrust", r=> true)// r => Actionmanager.LastSpellId == 0 || Actionmanager.LastSpell.Name == "Full Thrust" )

                
                );
        }
    }
}
