﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using TreeSharp;

using Action = TreeSharp.Action;
namespace Kupo.Rotations
{
    public class MaruaderWarrior : KupoRoutine
    {
        public override int PullRange
        {
            get { return 5; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[]{ClassJobType.Marauder, ClassJobType.Warrior, };}
        }

        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        protected override Composite CreatePull()
        {
            return new PrioritySelector(
                r=> Actionmanager.InSpellInRangeLOS("Heavy Swing", Core.Target),
                new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                Cast("Heavy Swing", r => (r as SpellRangeCheck?) == SpellRangeCheck.Success || (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInFront)
            );


        }

        protected override Composite CreateHeal()
        {
            return new PrioritySelector(
                Apply("Foresight", r => Core.Player.CurrentHealthPercent <= 80),
                Apply("Bloodbath", r => Core.Player.CurrentHealthPercent <= 80),
                Cast("Inner Beast", r => Core.Player.CurrentHealthPercent <= 60 && Core.Player.HasAura("Infuriated")),
                Cast("Convalescence", r => Core.Player.CurrentHealthPercent <= 50),
                Apply("Thrill of Battle", r => Core.Player.CurrentHealthPercent <= 30)
            );
        }

        protected override Composite CreateCombat()
        {
            return new PrioritySelector(
                Apply("Fracture"),
				Cast("Storm's Eye", r => Actionmanager.LastSpell.Name == "Maim"),
				Cast("Butcher's Block", r => Actionmanager.LastSpell.Name == "Skull Sunder"),
				Cast("Skull Sunder", r => Actionmanager.LastSpell.Name == "Heavy Swing" && !Actionmanager.HasSpell("Maim") || Core.Player.HasAura("Maim")),
				Cast("Maim", r => Actionmanager.LastSpell.Name == "Heavy Swing"),
				Cast("Heavy Swing", r => true)
            );
        }
    }
}
