﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupo.Rotations
{
    public class PugilistMonk : KupoRoutine
    {
        public override int PullRange
        {
            get { return 5; }
        }

        public override ClassJobType[] Class
        {
            get { return new ClassJobType[] { ClassJobType.Pugilist, ClassJobType.Monk, }; }
        }


        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentTPPercent);
        }

        protected override Composite CreatePull()
        {
            return new PrioritySelector(
                r => Actionmanager.InSpellInRangeLOS("Bootshine", Core.Target),
                new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                Cast("Bootshine", r => (r as SpellRangeCheck?) == SpellRangeCheck.Success || (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInFront)
            );


        }

        protected override Composite CreateCombat()
        {
            return new PrioritySelector(

                Cast("Snap Punch", r => Core.Player.HasAura("Coeurl Form")),
                Cast("True Strike", r => Core.Player.HasAura("Raptor Form")),
                Cast("Bootshine", r => true)// r => Actionmanager.LastSpellId == 0 || Actionmanager.LastSpell.Name == "Full Thrust" )


                );
        }
    }
}
