﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Managers;
using ff14bot.Navigation;
using Kupo;
using TreeSharp;
using Action = TreeSharp.Action;

namespace Kupo.Rotations
{
	class Thaumaturge : KupoRoutine
	{
		public override ClassJobType[] Class
		{
			get { return new[] { ClassJobType.Thaumaturge }; }
		}
		public override int PullRange
		{
			get { return 20; }
		}

        protected override Composite CreatePreCombatBuffs()
        {
            return SummonChocobo();
        }

        protected override Composite CreateRest()
        {
            return DefaultRestBehavior(r => Core.Player.CurrentManaPercent);
        }




        private string[] PullSpells = new[] { "Thunder II", "Thunder" };
        private string _BestPullSpell;
        private string BestPullSpell
        {
            get
            {
                if (string.IsNullOrEmpty(_BestPullSpell))
                {
                    foreach (var spell in PullSpells)
                    {
                        if (Actionmanager.HasSpell(spell))
                        {
                            _BestPullSpell = spell;
                            return spell;
                        }
                    }
                    _BestPullSpell = "Blizzard";
                    return "Blizzard";
                }
                else
                {
                    return _BestPullSpell;
                }
            }
        }




        protected override Composite CreatePull()
        {
            return new PrioritySelector(
                
                r => Actionmanager.InSpellInRangeLOS(BestPullSpell, Core.Target),
                EnsureTarget,
                new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                //new Decorator(r => (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInRange, new Action(r => Navigator.MoveTo(Core.Target.Location))),
                Apply(BestPullSpell, r => (r as SpellRangeCheck?) == SpellRangeCheck.Success || (r as SpellRangeCheck?) == SpellRangeCheck.ErrorNotInFront)
            );


        }



		protected override Composite CreateCombatBuffs()
		{
			return new PrioritySelector(
				//Dem deepz
				Apply("Raging Strikes"),
				Apply("Swiftcast")
			);
		}
		protected override Composite CreateHeal()
		{
			return new PrioritySelector(
				Apply("Manaward", r => Core.Player.CurrentHealthPercent <= 80),
				Apply("Manawall", r => Core.Player.CurrentHealthPercent <= 80),
				Cast("Physick", r => Core.Player.CurrentHealthPercent <= 40, r => Core.Player)
			);
		}
		protected override Composite CreateCombat()
		{
			return new PrioritySelector(

                EnsureTarget,
                Apply("Thunder"),
				Cast("Blizzard", r => Core.Player.CurrentManaPercent <= 60),
				Cast("Fire")
			);
		}
	}
}